diff -ru gcc-3.4.6/gcc/config/avr/avr.c gcc-3.4.6-new/gcc/config/avr/avr.c
--- gcc-3.4.6/gcc/config/avr/avr.c	2005-03-21 06:14:28.000000000 +0900
+++ gcc-3.4.6-new/gcc/config/avr/avr.c	2007-12-18 05:21:24.000000000 +0900
@@ -175,6 +175,19 @@
   { "at90c8534", 2, "__AVR_AT90C8534__" },
   { "at90s8535", 2, "__AVR_AT90S8535__" },
   { "at86rf401", 2, "__AVR_AT86RF401__" },
+
+    /* Classic + MOVW, <= 8K.  */
+  { "attiny13",  2, "__AVR_ATtiny13__" },
+  { "attiny2313",  2, "__AVR_ATtiny2313__" },
+  { "attiny25",  2, "__AVR_ATtiny25__" },
+  { "attiny45",  2, "__AVR_ATtiny45__" },
+  { "attiny85",  2, "__AVR_ATtiny85__" },
+  { "attiny24",  2, "__AVR_ATtiny24__" },
+  { "attiny44",  2, "__AVR_ATtiny44__" },
+  { "attiny84",  2, "__AVR_ATtiny84__" },
+  { "attiny261",  2, "__AVR_ATtiny261__" },
+  { "attiny461",  2, "__AVR_ATtiny461__" },
+  { "attiny861",  2, "__AVR_ATtiny861__" },
     /* Classic, > 8K.  */
   { "avr3",      3, NULL },
   { "atmega103", 3, "__AVR_ATmega103__" },
@@ -182,11 +195,21 @@
   { "at43usb320", 3, "__AVR_AT43USB320__" },
   { "at43usb355", 3, "__AVR_AT43USB355__" },
   { "at76c711",  3, "__AVR_AT76C711__" },
+    /* Classic + MOVW, > 8K.  */
+  { "at90usb82", 3, "__AVR_AT90USB82__" },
+  { "at90usb162", 3, "__AVR_AT90USB162__" },
     /* Enhanced, <= 8K.  */
   { "avr4",      4, NULL },
   { "atmega8",   4, "__AVR_ATmega8__" },
   { "atmega8515", 4, "__AVR_ATmega8515__" },
   { "atmega8535", 4, "__AVR_ATmega8535__" },
+  { "atmega48",  4, "__AVR_ATmega48__" },
+  { "atmega88",  4, "__AVR_ATmega88__" },
+  { "at90pwm1",  4, "__AVR_AT90PWM1__" },
+  { "at90pwm2",  4, "__AVR_AT90PWM2__" },
+  { "at90pwm3",  4, "__AVR_AT90PWM3__" },
+  { "atmega48p",  4, "__AVR_ATmega48P__" },
+  { "atmega88p",  4, "__AVR_ATmega88P__" },
     /* Enhanced, > 8K.  */
   { "avr5",      5, NULL },
   { "atmega16",  5, "__AVR_ATmega16__" },
@@ -199,6 +222,12 @@
   { "atmega64",  5, "__AVR_ATmega64__" },
   { "atmega128", 5, "__AVR_ATmega128__" },
   { "at94k",     5, "__AVR_AT94K__" },
+  { "atmega168",  5, "__AVR_ATmega168__" },
+  { "at90pwm216",  5, "__AVR_AT90PWM216__" },
+  { "at90pwm316",  5, "__AVR_AT90PWM316__" },
+  { "atmega168p",  5, "__AVR_ATmega168P__" },
+  { "atmega328p",  5, "__AVR_ATmega328P__" },
+  { "atmega644",  5, "__AVR_ATmega644__" },
     /* Assembler only.  */
   { "avr1",      1, NULL },
   { "at90s1200", 1, "__AVR_AT90S1200__" },
diff -ru gcc-3.4.6/gcc/config/avr/avr.h gcc-3.4.6-new/gcc/config/avr/avr.h
--- gcc-3.4.6/gcc/config/avr/avr.h	2004-03-09 12:00:15.000000000 +0900
+++ gcc-3.4.6-new/gcc/config/avr/avr.h	2007-12-18 05:23:35.000000000 +0900
@@ -2351,12 +2351,12 @@
    Do not define this macro if it does not need to do anything.  */
 
 #define LINK_SPEC " %{!mmcu*:-m avr2}\
-%{mmcu=at90s1200|mmcu=attiny1*|mmcu=attiny28:-m avr1} \
-%{mmcu=attiny22|mmcu=attiny26|mmcu=at90s2*|mmcu=at90s4*|mmcu=at90s8*|mmcu=at90c8*|mmcu=at86rf401:-m avr2}\
-%{mmcu=atmega103|mmcu=atmega603|mmcu=at43*|mmcu=at76*:-m avr3}\
-%{mmcu=atmega8*:-m avr4}\
-%{mmcu=atmega16*|mmcu=atmega32*|mmcu=atmega64|mmcu=atmega128|mmcu=at94k:-m avr5}\
-%{mmcu=atmega64|mmcu=atmega128|mmcu=atmega162|mmcu=atmega169: -Tdata 0x800100} "
+%{mmcu=at90s1200|mmcu=attiny11|mmcu=attiny28:-m avr1} \
+%{mmcu=attiny22|mmcu=attiny26|mmcu=at90s2*|mmcu=at90s4*|mmcu=at90s8*|mmcu=at90c8*|mmcu=at86rf401|mmcu=attiny2313|mmcu=attiny25|mmcu=attiny45|mmcu=attiny85|mmcu=attiny24|mmcu=attiny44|mmcu=attiny84|mmcu=attiny261|mmcu=attiny461|mmcu=attiny861:-m avr2}\
+%{mmcu=atmega103|mmcu=atmega603|mmcu=at43*|mmcu=at76*|mmcu=at90usb82|mmcu=at90usb162:-m avr3}\
+%{mmcu=atmega8*|mmcu=attiny48*|mmcu=at90pwm1|mmcu=at90pwm2|mmcu=at90pwm3:-m avr4}\
+%{mmcu=atmega16*|mmcu=atmega32*|mmcu=atmega64*|mmcu=atmega128|mmcu=at94k|mmcu=at90pwm216|mmcu=at90pwm316:-m avr5}\
+%{mmcu=atmega64|mmcu=atmega128|mmcu=atmega162|mmcu=atmega169|mmcu=atmega48*|mmcu=atmega88*|mmcu=atmega168*|mmcu=atmega328*|mmcu=atmega644|mmcu=at90pwm*|mmcu=at90usb*: -Tdata 0x800100} "
 
 /* A C string constant that tells the GCC driver program options to
    pass to the linker.  It can also specify how to translate options
@@ -2365,7 +2365,7 @@
    Do not define this macro if it does not need to do anything.  */
 
 #define LIB_SPEC \
-  "%{!mmcu=at90s1*:%{!mmcu=attiny1*:%{!mmcu=attiny28: -lc }}}"
+  "%{!mmcu=at90s1*:%{!mmcu=attiny11:%{!mmcu=attiny28: -lc }}}"
 /* Another C string constant used much like `LINK_SPEC'.  The
    difference between the two is that `LIB_SPEC' is used at the end
    of the command given to the linker.
@@ -2377,7 +2377,7 @@
 /* No libstdc++ for now.  Empty string doesn't work.  */
 
 #define LIBGCC_SPEC \
-  "%{!mmcu=at90s1*:%{!mmcu=attiny1*:%{!mmcu=attiny28: -lgcc }}}"
+  "%{!mmcu=at90s1*:%{!mmcu=attiny11:%{!mmcu=attiny28: -lgcc }}}"
 /* Another C string constant that tells the GCC driver program how
    and when to place a reference to `libgcc.a' into the linker
    command line.  This constant is placed both before and after the
@@ -2421,14 +2421,34 @@
 %{mmcu=at90c8534:crtc8534.o%s} \
 %{mmcu=at90s8535:crts8535.o%s} \
 %{mmcu=at86rf401:crt86401.o%s} \
+%{mmcu=attiny13:crttn13.o%s} \
+%{mmcu=attiny2313:crttn2313.o%s} \
+%{mmcu=attiny25:crttn25.o%s} \
+%{mmcu=attiny45:crttn45.o%s} \
+%{mmcu=attiny85:crttn85.o%s} \
+%{mmcu=attiny24:crttn24.o%s} \
+%{mmcu=attiny44:crttn44.o%s} \
+%{mmcu=attiny84:crttn84.o%s} \
+%{mmcu=attiny261:crttn261.o%s} \
+%{mmcu=attiny461:crttn461.o%s} \
+%{mmcu=attiny861:crttn861.o%s} \
 %{mmcu=atmega103|mmcu=avr3:crtm103.o%s} \
 %{mmcu=atmega603:crtm603.o%s} \
 %{mmcu=at43usb320:crt43320.o%s} \
 %{mmcu=at43usb355:crt43355.o%s} \
 %{mmcu=at76c711:crt76711.o%s} \
+%{mmcu=at90usb82:crtusb82.o%s} \
+%{mmcu=at90usb162:crtusb162.o%s} \
 %{mmcu=atmega8|mmcu=avr4:crtm8.o%s} \
 %{mmcu=atmega8515:crtm8515.o%s} \
 %{mmcu=atmega8535:crtm8535.o%s} \
+%{mmcu=atmega48:crtm48.o%s} \
+%{mmcu=atmega88:crtm88.o%s} \
+%{mmcu=at90pwm1:crt90pwm1.o%s} \
+%{mmcu=at90pwm2:crt90pwm2.o%s} \
+%{mmcu=at90pwm3:crt90pwm3.o%s} \
+%{mmcu=atmega48p:crtm48.o%s} \
+%{mmcu=atmega88p:crtm88.o%s} \
 %{mmcu=atmega16:crtm16.o%s} \
 %{mmcu=atmega161|mmcu=avr5:crtm161.o%s} \
 %{mmcu=atmega162:crtm162.o%s} \
@@ -2438,7 +2458,13 @@
 %{mmcu=atmega323:crtm323.o%s} \
 %{mmcu=atmega64:crtm64.o%s} \
 %{mmcu=atmega128:crtm128.o%s} \
-%{mmcu=at94k:crtat94k.o%s}"
+%{mmcu=at94k:crtat94k.o%s} \
+%{mmcu=atmega168:crtm168.o%s} \
+%{mmcu=atmega644:crtm644.o%s} \
+%{mmcu=atmega168p:crtm168.o%s} \
+%{mmcu=atmega328p:crtm328p.o%s} \
+%{mmcu=at90pwm216:crt90pwm216.o%s} \
+%{mmcu=at90pwm316:crt90pwm316.o%s} "
 
 #define EXTRA_SPECS {"crt_binutils", CRT_BINUTILS_SPECS},
 
diff -ru gcc-3.4.6/gcc/config/avr/t-avr gcc-3.4.6-new/gcc/config/avr/t-avr
--- gcc-3.4.6/gcc/config/avr/t-avr	2005-04-25 13:17:34.000000000 +0900
+++ gcc-3.4.6-new/gcc/config/avr/t-avr	2007-12-18 05:21:24.000000000 +0900
@@ -45,14 +45,23 @@
 	mmcu?avr3=mmcu?atmega103 mmcu?avr3=mmcu?atmega603 \
 	mmcu?avr3=mmcu?at43usb320 mmcu?avr3=mmcu?at43usb355 \
 	mmcu?avr3=mmcu?at76c711 \
+	mmcu?avr3=mmcu?at90usb82 mmcu?avr3=mmcu?at90usb162 \
 	mmcu?avr4=mmcu?atmega8515 mmcu?avr4=mmcu?atmega8535 \
 	mmcu?avr4=mmcu?atmega8 \
+	mmcu?avr4=mmcu?atmega48 mmcu?avr4=mmcu?atmega48p \
+	mmcu?avr4=mmcu?atmega88 mmcu?avr4=mmcu?atmega88p \
+	mmcu?avr4=mmcu?at90pwm1 mmcu?avr4=mmcu?at90pwm2 \
+	mmcu?avr4=mmcu?at90pwm3 \
 	mmcu?avr5=mmcu?atmega161 mmcu?avr5=mmcu?atmega162 \
 	mmcu?avr5=mmcu?atmega163 mmcu?avr5=mmcu?atmega169 \
 	mmcu?avr5=mmcu?atmega16 \
 	mmcu?avr5=mmcu?atmega323 mmcu?avr5=mmcu?atmega32 \
 	mmcu?avr5=mmcu?atmega64  mmcu?avr5=mmcu?atmega128 \
 	mmcu?avr5=mmcu?at94k
+	mmcu?avr5=mmcu?atmega168 mmcu?avr5=mmcu?atmega168p \
+	mmcu?avr5=mmcu?atmega328p \
+	mmcu?avr5=mmcu?at90pwm216 mmcu?avr5=mmcu?at90pwm316 \
+	mmcu?avr5=mmcu?atmega644 \
 
 MULTILIB_EXCEPTIONS =
 
